b1 = BSplineBasis(1, 0:5)

B₁ = x -> Int(0 ≤ x < 1)
B₂ = x -> Int(1 ≤ x < 2)
B₃ = x -> Int(2 ≤ x < 3)
B₄ = x -> Int(3 ≤ x < 4)
B₅ = x -> Int(4 ≤ x ≤ 5)

b1_exact = [B₁, B₂, B₃, B₄, B₅]

b2 = BSplineBasis(2, big(0):1:big(5))

B₁ = x -> 0 ≤ x < 1 ? -x + 1 : 0*one(x)
B₂ = x -> 0 ≤ x < 1 ?  x + 0 :
          1 ≤ x < 2 ? -x + 2 : 0*one(x)
B₃ = x -> 1 ≤ x < 2 ?  x - 1 :
          2 ≤ x < 3 ? -x + 3 : 0*one(x)
B₄ = x -> 2 ≤ x < 3 ?  x - 2 :
          3 ≤ x < 4 ? -x + 4 : 0*one(x)
B₅ = x -> 3 ≤ x < 4 ?  x - 3 :
          4 ≤ x ≤ 5 ? -x + 5 : 0*one(x)
B₆ = x -> 4 ≤ x ≤ 5 ?  x - 4 : 0*one(x)
# 1st derivatives
B₁′ = x -> 0 ≤ x < 1 ? -1*one(x) : 0*one(x)
B₂′ = x -> 0 ≤ x < 1 ?  1*one(x) :
           1 ≤ x < 2 ? -1*one(x) : 0*one(x)
B₃′ = x -> 1 ≤ x < 2 ?  1*one(x) :
           2 ≤ x < 3 ? -1*one(x) : 0*one(x)
B₄′ = x -> 2 ≤ x < 3 ?  1*one(x) :
           3 ≤ x < 4 ? -1*one(x) : 0*one(x)
B₅′ = x -> 3 ≤ x < 4 ?  1*one(x) :
           4 ≤ x ≤ 5 ? -1*one(x) : 0*one(x)
B₆′ = x -> 4 ≤ x ≤ 5 ?  1*one(x) : 0*one(x)

b2_exact = [B₁ B₁′; B₂ B₂′; B₃ B₃′; B₄ B₄′; B₅ B₅′; B₆ B₆′]

b3 = BSplineBasis(3, 0//1:5//1)

B₁ = x -> 0 ≤ x < 1 ? 1//1*x^2 - 2//1*x + 1//1 : 0//1*one(x)
B₂ = x -> 0 ≤ x < 1 ? -3//2*x^2 + 2//1*x        :
          1 ≤ x < 2 ?  1//2*x^2 - 2//1*x + 2//1 : 0//1*one(x)
B₃ = x -> 0 ≤ x < 1 ?  1//2*x^2                 :
          1 ≤ x < 2 ? -1//1*x^2 + 3//1*x - 3//2 :
          2 ≤ x < 3 ?  1//2*x^2 - 3//1*x + 9//2 : 0//1*one(x)
B₄ = x -> 1 ≤ x < 2 ?  1//2*x^2 - 1//1*x +  1//2 :
          2 ≤ x < 3 ? -1//1*x^2 + 5//1*x - 11//2 :
          3 ≤ x < 4 ?  1//2*x^2 - 4//1*x +  8//1 : 0//1*one(x)
B₅ = x -> 2 ≤ x < 3 ?  1//2*x^2 - 2//1*x +  2//1 :
          3 ≤ x < 4 ? -1//1*x^2 + 7//1*x - 23//2 :
          4 ≤ x ≤ 5 ?  1//2*x^2 - 5//1*x + 25//2 : 0//1*one(x)
B₆ = x -> 3 ≤ x < 4 ?  1//2*x^2 -  3//1*x +  9//2 :
          4 ≤ x ≤ 5 ? -3//2*x^2 + 13//1*x - 55//2 : 0//1*one(x)
B₇ = x -> 4 ≤ x ≤ 5 ? 1//1*x^2 - 8//1*x + 16//1 : 0//1*one(x)
# 1st derivatives
B₁′ = x -> 0 ≤ x < 1 ? 2//1*x - 2//1 : 0//1*one(x)
B₂′ = x -> 0 ≤ x < 1 ? -3//1*x + 2//1 :
           1 ≤ x < 2 ?  1//1*x - 2//1 : 0//1*one(x)
B₃′ = x -> 0 ≤ x < 1 ?  1//1*x        :
           1 ≤ x < 2 ? -2//1*x + 3//1 :
           2 ≤ x < 3 ?  1//1*x - 3//1 : 0//1*one(x)
B₄′ = x -> 1 ≤ x < 2 ?  1//1*x - 1//1 :
           2 ≤ x < 3 ? -2//1*x + 5//1 :
           3 ≤ x < 4 ?  1//1*x - 4//1 : 0//1*one(x)
B₅′ = x -> 2 ≤ x < 3 ?  1//1*x - 2//1 :
           3 ≤ x < 4 ? -2//1*x + 7//1 :
           4 ≤ x ≤ 5 ?  1//1*x - 5//1 : 0//1*one(x)
B₆′ = x -> 3 ≤ x < 4 ?  1//1*x -  3//1 :
           4 ≤ x ≤ 5 ? -3//1*x + 13//1 : 0//1*one(x)
B₇′ = x -> 4 ≤ x ≤ 5 ? 2//1*x - 8//1 : 0//1*one(x)
# 2nd derivatives
B₁′′ = x -> 0 ≤ x < 1 ? 2//1*one(x) : 0//1*one(x)
B₂′′ = x -> 0 ≤ x < 1 ? -3//1*one(x) :
            1 ≤ x < 2 ?  1//1*one(x) : 0//1*one(x)
B₃′′ = x -> 0 ≤ x < 1 ?  1//1*one(x) :
            1 ≤ x < 2 ? -2//1*one(x) :
            2 ≤ x < 3 ?  1//1*one(x) : 0//1*one(x)
B₄′′ = x -> 1 ≤ x < 2 ?  1//1*one(x) :
            2 ≤ x < 3 ? -2//1*one(x) :
            3 ≤ x < 4 ?  1//1*one(x) : 0//1*one(x)
B₅′′ = x -> 2 ≤ x < 3 ?  1//1*one(x) :
            3 ≤ x < 4 ? -2//1*one(x) :
            4 ≤ x ≤ 5 ?  1//1*one(x) : 0//1*one(x)
B₆′′ = x -> 3 ≤ x < 4 ?  1//1*one(x) :
            4 ≤ x ≤ 5 ? -3//1*one(x) : 0//1*one(x)
B₇′′ = x -> 4 ≤ x ≤ 5 ? 2//1*one(x) : 0//1*one(x)

b3_exact = [B₁ B₁′ B₁′′; B₂ B₂′ B₂′′; B₃ B₃′ B₃′′; B₄ B₄′ B₄′′; B₅ B₅′ B₅′′; B₆ B₆′ B₆′′; B₇ B₇′ B₇′′]

b4 = BSplineBasis(4, Int128[0,1,2,3,4,5])

B₁ = x -> 0 ≤ x < 1 ? -1//1*x^3 + 3//1*x^2 - 3//1*x + 1//1 : 0//1*one(x)
B₂ = x -> 0 ≤ x < 1 ?  7//4*x^3 - 9//2*x^2 + 3//1*x        :
          1 ≤ x < 2 ? -1//4*x^3 + 3//2*x^2 - 3//1*x + 2//1 : 0//1*one(x)
B₃ = x -> 0 ≤ x < 1 ? -11//12*x^3 + 3//2*x^2                 :
          1 ≤ x < 2 ?   7//12*x^3 - 3//1*x^2 + 9//2*x - 3//2 :
          2 ≤ x < 3 ?   -1//6*x^3 + 3//2*x^2 - 9//2*x + 9//2 : 0//1*one(x)
B₄ = x -> 0 ≤ x < 1 ?  1//6*x^3                      :
          1 ≤ x < 2 ? -1//2*x^3 + 2//1*x^2 -  2//1*x +  2//3 :
          2 ≤ x < 3 ?  1//2*x^3 - 4//1*x^2 + 10//1*x - 22//3 :
          3 ≤ x < 4 ? -1//6*x^3 + 2//1*x^2 -  8//1*x + 32//3 : 0//1*one(x)
B₅ = x -> 1 ≤ x < 2 ?  1//6*x^3 -  1//2*x^2 +  1//2*x -   1//6 :
          2 ≤ x < 3 ? -1//2*x^3 +  7//2*x^2 - 15//2*x +  31//6 :
          3 ≤ x < 4 ?  1//2*x^3 - 11//2*x^2 + 39//2*x - 131//6 :
          4 ≤ x ≤ 5 ? -1//6*x^3 +  5//2*x^2 - 25//2*x + 125//6 : 0//1*one(x)
B₆ = x -> 2 ≤ x < 3 ?   1//6*x^3 -  1//1*x^2 +   2//1*x -    4//3 :
          3 ≤ x < 4 ? -7//12*x^3 + 23//4*x^2 -  73//4*x + 227//12 :
          4 ≤ x ≤ 5 ? 11//12*x^3 - 49//4*x^2 + 215//4*x - 925//12 : 0//1*one(x)
B₇ = x -> 3 ≤ x < 4 ?  1//4*x^3 -  9//4*x^2 +  27//4*x -  27//4 :
          4 ≤ x ≤ 5 ? -7//4*x^3 + 87//4*x^2 - 357//4*x + 485//4 : 0//1*one(x)
B₈ = x -> 4 ≤ x ≤ 5 ? 1//1*x^3 - 12//1*x^2 + 48//1*x - 64//1 : 0//1*one(x)
# 1st derivatives
B₁′ = x -> 0 ≤ x < 1 ? -3//1*x^2 + 6//1*x - 3//1 : 0//1*one(x)
B₂′ = x -> 0 ≤ x < 1 ? 21//4*x^2 - 9//1*x + 3//1 :
           1 ≤ x < 2 ? -3//4*x^2 + 3//1*x - 3//1 : 0//1*one(x)
B₃′ = x -> 0 ≤ x < 1 ? -11//4*x^2 + 3//1*x        :
           1 ≤ x < 2 ?   7//4*x^2 - 6//1*x + 9//2 :
           2 ≤ x < 3 ?  -1//2*x^2 + 3//1*x - 9//2 : 0//1*one(x)
B₄′ = x -> 0 ≤ x < 1 ?  1//2*x^2                  :
           1 ≤ x < 2 ? -3//2*x^2 + 4//1*x -  2//1 :
           2 ≤ x < 3 ?  3//2*x^2 - 8//1*x + 10//1 :
           3 ≤ x < 4 ? -1//2*x^2 + 4//1*x -  8//1 : 0//1*one(x)
B₅′ = x -> 1 ≤ x < 2 ?  1//2*x^2 -  1//1*x +  1//2 :
           2 ≤ x < 3 ? -3//2*x^2 +  7//1*x - 15//2 :
           3 ≤ x < 4 ?  3//2*x^2 - 11//1*x + 39//2 :
           4 ≤ x ≤ 5 ? -1//2*x^2 +  5//1*x - 25//2 : 0//1*one(x)
B₆′ = x -> 2 ≤ x < 3 ?  1//2*x^2 -  2//1*x +   2//1 :
           3 ≤ x < 4 ? -7//4*x^2 + 23//2*x -  73//4 :
           4 ≤ x ≤ 5 ? 11//4*x^2 - 49//2*x + 215//4 : 0//1*one(x)
B₇′ = x -> 3 ≤ x < 4 ?   3//4*x^2 -  9//2*x +  27//4 :
           4 ≤ x ≤ 5 ? -21//4*x^2 + 87//2*x - 357//4 : 0//1*one(x)
B₈′ = x -> 4 ≤ x ≤ 5 ? 3//1*x^2 - 24//1*x + 48//1 : 0//1*one(x)
# 2nd derivatives
B₁′′ = x -> 0 ≤ x < 1 ? -6//1*x + 6//1 : 0//1*one(x)
B₂′′ = x -> 0 ≤ x < 1 ? 21//2*x - 9//1 :
            1 ≤ x < 2 ? -3//2*x + 3//1 : 0//1*one(x)
B₃′′ = x -> 0 ≤ x < 1 ? -11//2*x + 3//1 :
            1 ≤ x < 2 ?   7//2*x - 6//1 :
            2 ≤ x < 3 ?  -1//1*x + 3//1 : 0//1*one(x)
B₄′′ = x -> 0 ≤ x < 1 ?  1//1*x        :
            1 ≤ x < 2 ? -3//1*x + 4//1 :
            2 ≤ x < 3 ?  3//1*x - 8//1 :
            3 ≤ x < 4 ? -1//1*x + 4//1 : 0//1*one(x)
B₅′′ = x -> 1 ≤ x < 2 ?  1//1*x -  1//1 :
            2 ≤ x < 3 ? -3//1*x +  7//1 :
            3 ≤ x < 4 ?  3//1*x - 11//1 :
            4 ≤ x ≤ 5 ? -1//1*x +  5//1 : 0//1*one(x)
B₆′′ = x -> 2 ≤ x < 3 ?  1//1*x -  2//1 :
            3 ≤ x < 4 ? -7//2*x + 23//2 :
            4 ≤ x ≤ 5 ? 11//2*x - 49//2 : 0//1*one(x)
B₇′′ = x -> 3 ≤ x < 4 ?   3//2*x -  9//2 :
            4 ≤ x ≤ 5 ? -21//2*x + 87//2 : 0//1*one(x)
B₈′′ = x -> 4 ≤ x ≤ 5 ? 6//1*x - 24//1 : 0//1*one(x)
# 3rd derivatives
B₁′′′ = x -> 0 ≤ x < 1 ? -6//1 : 0//1*one(x)
B₂′′′ = x -> 0 ≤ x < 1 ? 21//2 :
             1 ≤ x < 2 ? -3//2 : 0//1*one(x)
B₃′′′ = x -> 0 ≤ x < 1 ? -11//2 :
             1 ≤ x < 2 ?   7//2 :
             2 ≤ x < 3 ?  -1//1 : 0//1*one(x)
B₄′′′ = x -> 0 ≤ x < 1 ?  1//1 :
             1 ≤ x < 2 ? -3//1 :
             2 ≤ x < 3 ?  3//1 :
             3 ≤ x < 4 ? -1//1 : 0//1*one(x)
B₅′′′ = x -> 1 ≤ x < 2 ?  1//1 :
             2 ≤ x < 3 ? -3//1 :
             3 ≤ x < 4 ?  3//1 :
             4 ≤ x ≤ 5 ? -1//1 : 0//1*one(x)
B₆′′′ = x -> 2 ≤ x < 3 ?  1//1 :
             3 ≤ x < 4 ? -7//2 :
             4 ≤ x ≤ 5 ? 11//2 : 0//1*one(x)
B₇′′′ = x -> 3 ≤ x < 4 ?   3//2 :
             4 ≤ x ≤ 5 ? -21//2 : 0//1*one(x)
B₈′′′ = x -> 4 ≤ x ≤ 5 ? 6//1 : 0//1*one(x)

b4_exact = [B₁ B₁′ B₁′′ B₁′′′; B₂ B₂′ B₂′′ B₂′′′; B₃ B₃′ B₃′′ B₃′′′; B₄ B₄′ B₄′′ B₄′′′;
            B₅ B₅′ B₅′′ B₅′′′; B₆ B₆′ B₆′′ B₆′′′; B₇ B₇′ B₇′′ B₇′′′; B₈ B₈′ B₈′′ B₈′′′]

b5 = BSplineBasis(3, [-5.0, -3.5, -2.2, 1.0, 2.0, 3.6])

# The exact B-spline functions are for the breakpoint sequence [-5, -7//2, -11//5, 1, 2, 18//5].
# Note that this is not exactly equal to [-5.0, -3.5, -2.2, 1.0, 2.0, 3.6], because the
# floating-point representations of -11//5 and 18//5 are not exact.
B₁ = x -> -5.0 ≤ x < -3.5 ? 4//9*x^2 + 28//9*x + 49//9 : 0//1*one(x)
B₂ = x -> -5.0 ≤ x < -3.5 ? -43//63*x^2 - 346//63*x - 655//63 :
          -3.5 ≤ x < -2.2 ?  25//91*x^2 + 110//91*x + 121//91 : 0//1*one(x)
B₃ = x -> -5.0 ≤ x < -3.5 ?     5//21*x^2 +    50//21*x +   125//21 :
          -3.5 ≤ x < -2.2 ? -365//819*x^2 - 1970//819*x - 1985//819 :
          -2.2 ≤ x <  1.0 ?     5//72*x^2 -     5//36*x +     5//72 : 0//1*one(x)
B₄ = x -> -3.5 ≤ x < -2.2 ?    20//117*x^2 + 140//117*x +  245//117 :
          -2.2 ≤ x <  1.0 ? -145//1008*x^2 -  95//504*x + 575//1008 :
           1.0 ≤ x <  2.0 ?      5//21*x^2 -   20//21*x +    20//21 : 0//1*one(x)
B₅ = x -> -2.2 ≤ x < 1.0 ?   25//336*x^2 +  55//168*x + 121//336 :
           1.0 ≤ x < 2.0 ? -170//273*x^2 + 470//273*x -  92//273 :
           2.0 ≤ x ≤ 3.6 ?   25//104*x^2 -   45//26*x +   81//26 : 0//1*one(x)
B₆ = x ->  1.0 ≤ x < 2.0 ?     5//13*x^2 -   10//13*x +    5//13 :
           2.0 ≤ x ≤ 3.6 ? -525//832*x^2 + 685//208*x - 765//208 : 0//1*one(x)
B₇ = x ->  2.0 ≤ x ≤ 3.6 ? 25//64*x^2 - 25//16*x + 25//16 : 0//1*one(x)
# 1st derivatives
B₁′ = x -> -5.0 ≤ x < -3.5 ? 8//9*x + 28//9 : 0//1*one(x)
B₂′ = x -> -5.0 ≤ x < -3.5 ? -86//63*x - 346//63 :
           -3.5 ≤ x < -2.2 ?  50//91*x + 110//91 : 0//1*one(x)
B₃′ = x -> -5.0 ≤ x < -3.5 ?    10//21*x +    50//21 :
           -3.5 ≤ x < -2.2 ? -730//819*x - 1970//819 :
           -2.2 ≤ x <  1.0 ?     5//36*x -     5//36 : 0//1*one(x)
B₄′ = x -> -3.5 ≤ x < -2.2 ?   40//117*x + 140//117 :
           -2.2 ≤ x <  1.0 ? -145//504*x -  95//504 :
            1.0 ≤ x <  2.0 ?    10//21*x -   20//21 : 0//1*one(x)
B₅′ = x -> -2.2 ≤ x < 1.0 ?   25//168*x +  55//168 :
            1.0 ≤ x < 2.0 ? -340//273*x + 470//273 :
            2.0 ≤ x ≤ 3.6 ?    25//52*x -   45//26 : 0//1*one(x)
B₆′ = x ->  1.0 ≤ x < 2.0 ?    10//13*x -   10//13 :
            2.0 ≤ x ≤ 3.6 ? -525//416*x + 685//208 : 0//1*one(x)
B₇′ = x ->  2.0 ≤ x ≤ 3.6 ? 25//32*x - 25//16 : 0//1*one(x)
# 2nd derivatives
B₁′′ = x -> -5.0 ≤ x < -3.5 ? 8//9*one(x) : 0//1*one(x)
B₂′′ = x -> -5.0 ≤ x < -3.5 ? -86//63*one(x) :
            -3.5 ≤ x < -2.2 ?  50//91*one(x) : 0//1*one(x)
B₃′′ = x -> -5.0 ≤ x < -3.5 ?    10//21*one(x) :
            -3.5 ≤ x < -2.2 ? -730//819*one(x) :
            -2.2 ≤ x <  1.0 ?     5//36*one(x) : 0//1*one(x)
B₄′′ = x -> -3.5 ≤ x < -2.2 ?   40//117*one(x) :
            -2.2 ≤ x <  1.0 ? -145//504*one(x) :
             1.0 ≤ x <  2.0 ?    10//21*one(x) : 0//1*one(x)
B₅′′ = x -> -2.2 ≤ x < 1.0 ?   25//168*one(x) :
             1.0 ≤ x < 2.0 ? -340//273*one(x) :
             2.0 ≤ x ≤ 3.6 ?    25//52*one(x) : 0//1*one(x)
B₆′′ = x ->  1.0 ≤ x < 2.0 ?    10//13*one(x) :
             2.0 ≤ x ≤ 3.6 ? -525//416*one(x) : 0//1*one(x)
B₇′′ = x ->  2.0 ≤ x ≤ 3.6 ? 25//32*one(x) : 0//1*one(x)

b5_exact = [B₁ B₁′ B₁′′; B₂ B₂′ B₂′′; B₃ B₃′ B₃′′; B₄ B₄′ B₄′′; B₅ B₅′ B₅′′; B₆ B₆′ B₆′′; B₇ B₇′ B₇′′]

b6 = BSplineBasis(4, Rational{BigInt}[-5//1, -7//2, -11//5, 1//1, 2//1, 18//5])

B₁ = x ->  -5//1 ≤ x <  -7//2 ? -8//27*x^3 - 28//9*x^2 - 98//9*x - 343//27 : 0//1*one(x)
B₂ = x ->  -5//1 ≤ x <  -7//2 ? 1429//2646*x^3 + 5339//882*x^2 + 19429//882*x + 69635//2646 :
           -7//2 ≤ x < -11//5 ? -125//1274*x^3 - 825//1274*x^2 - 1815//1274*x -  1331//1274 : 0//1*one(x)
B₃ = x ->  -5//1 ≤ x <  -7//2 ?   -125//441*x^3 -   520//147*x^2 -   2075//147*x -    7750//441 :
           -7//2 ≤ x < -11//5 ? 2965//17199*x^3 + 7160//5733*x^2 + 15115//5733*x + 33890//17199 :
          -11//5 ≤ x <   1//1 ?     -5//432*x^3 +     5//144*x^2 -      5//144*x +       5//432 : 0//1*one(x)
B₄ = x ->  -5//1 ≤ x <  -7//2 ?       5//126*x^3 +       25//42*x^2 +      125//42*x +     625//126 :
           -7//2 ≤ x < -11//5 ? -5695//54054*x^3 - 16715//18018*x^2 - 42415//18018*x - 68015//54054 :
          -11//5 ≤ x <   1//1 ?  1255//33264*x^3 +   185//11088*x^2 -  3065//11088*x +  8825//33264 :
            1//1 ≤ x <   2//1 ?     -10//231*x^3 +       20//77*x^2 -       40//77*x +      80//231 : 0//1*one(x)
B₅ = x ->  -7//2 ≤ x < -11//5 ?       40//1287*x^3 +      140//429*x^2 +      490//429*x +     1715//1287 :
          -11//5 ≤ x <   1//1 ? -12535//321552*x^3 - 14585//107184*x^2 + 13385//107184*x + 188599//321552 :
            1//1 ≤ x <   2//1 ?   13120//87087*x^3 -  20465//29029*x^2 +  20140//29029*x +   34564//87087 :
            2//1 ≤ x ≤  18//5 ?     -125//3016*x^3 +     675//1508*x^2 -     1215//754*x +       729//377 : 0//1*one(x)
B₆ = x -> -11//5 ≤ x <   1//1 ?      125//9744*x^3 +      275//3248*x^2 +     605//3248*x +    1331//9744 :
            1//1 ≤ x <   2//1 ? -26275//102921*x^3 +   30500//34307*x^2 -  21205//34307*x + 41654//102921 :
            2//1 ≤ x ≤  18//5 ?  89125//313664*x^3 - 368175//156832*x^2 + 459135//78416*x - 153333//39208 : 0//1*one(x)
B₇ = x ->   1//1 ≤ x <   2//1 ?       25//169*x^3 -       75//169*x^2 +       75//169*x -      25//169 :
            2//1 ≤ x <  18//5 ? -42125//86528*x^3 + 145575//43264*x^2 - 155175//21632*x + 53325//10816 : 0//1*one(x)
B₈ = x ->   2//1 ≤ x ≤  18//5 ? 125//512*x^3 - 375//256*x^2 + 375//128*x - 125//64 : 0//1*one(x)
# 1st derivatives
B₁′ = x ->  -5//1 ≤ x <  -7//2 ? -8//9*x^2 - 56//9*x - 98//9 : 0//1*one(x)
B₂′ = x ->  -5//1 ≤ x <  -7//2 ?  1429//882*x^2 + 5339//441*x + 19429//882 :
            -7//2 ≤ x < -11//5 ? -375//1274*x^2 -  825//637*x - 1815//1274 : 0//1*one(x)
B₃′ = x ->  -5//1 ≤ x <  -7//2 ?  -125//147*x^2 -   1040//147*x -   2075//147 :
            -7//2 ≤ x < -11//5 ? 2965//5733*x^2 + 14320//5733*x + 15115//5733 :
           -11//5 ≤ x <   1//1 ?    -5//144*x^2 +       5//72*x -      5//144 : 0//1*one(x)
B₄′ = x ->  -5//1 ≤ x <  -7//2 ?        5//42*x^2 +      25//21*x +      125//42 :
            -7//2 ≤ x < -11//5 ? -5695//18018*x^2 - 16715//9009*x - 42415//18018 :
           -11//5 ≤ x <   1//1 ?  1255//11088*x^2 +   185//5544*x -  3065//11088 :
             1//1 ≤ x <   2//1 ?      -10//77*x^2 +      40//77*x -       40//77 : 0//1*one(x)
B₅′ = x ->  -7//2 ≤ x < -11//5 ?        40//429*x^2 +     280//429*x +      490//429 :
           -11//5 ≤ x <   1//1 ? -12535//107184*x^2 - 14585//53592*x + 13385//107184 :
             1//1 ≤ x <   2//1 ?   13120//29029*x^2 - 40930//29029*x +  20140//29029 :
             2//1 ≤ x ≤  18//5 ?     -375//3016*x^2 +     675//754*x -     1215//754 : 0//1*one(x)
B₆′ = x -> -11//5 ≤ x <   1//1 ?      125//3248*x^2 +     275//1624*x +     605//3248 :
             1//1 ≤ x <   2//1 ?  -26275//34307*x^2 +  61000//34307*x -  21205//34307 :
             2//1 ≤ x ≤  18//5 ? 267375//313664*x^2 - 368175//78416*x + 459135//78416 : 0//1*one(x)
B₇′ = x ->   1//1 ≤ x <   2//1 ?        75//169*x^2 -      150//169*x +       75//169 :
             2//1 ≤ x ≤  18//5 ? -126375//86528*x^2 + 145575//21632*x - 155175//21632 : 0//1*one(x)
B₈′ = x ->   2//1 ≤ x ≤  18//5 ? 375//512*x^2 - 375//128*x + 375//128 : 0//1*one(x)
# 2nd derivatives
B₁′′ = x ->  -5//1 ≤ x <  -7//2 ? -16//9*x - 56//9 : 0//1*one(x)
B₂′′ = x ->  -5//1 ≤ x <  -7//2 ? 1429//441*x + 5339//441 :
             -7//2 ≤ x < -11//5 ? -375//637*x -  825//637 : 0//1*one(x)
B₃′′ = x ->  -5//1 ≤ x <  -7//2 ?  -250//147*x -   1040//147 :
             -7//2 ≤ x < -11//5 ? 5930//5733*x + 14320//5733 :
            -11//5 ≤ x <   1//1 ?     -5//72*x +       5//72 : 0//1*one(x)
B₄′′ = x ->  -5//1 ≤ x <  -7//2 ?       5//21*x +      25//21 :
             -7//2 ≤ x < -11//5 ? -5695//9009*x - 16715//9009 :
            -11//5 ≤ x <   1//1 ?  1255//5544*x +   185//5544 :
              1//1 ≤ x <   2//1 ?     -20//77*x +      40//77 : 0//1*one(x)
B₅′′ = x ->  -7//2 ≤ x < -11//5 ?       80//429*x +     280//429 :
            -11//5 ≤ x <   1//1 ? -12535//53592*x - 14585//53592 :
              1//1 ≤ x <   2//1 ?  26240//29029*x - 40930//29029 :
              2//1 ≤ x ≤  18//5 ?    -375//1508*x +     675//754 : 0//1*one(x)
B₆′′ = x -> -11//5 ≤ x <   1//1 ?      125//1624*x +     275//1624 :
              1//1 ≤ x <   2//1 ?  -52550//34307*x +  61000//34307 :
              2//1 ≤ x ≤  18//5 ? 267375//156832*x - 368175//78416 : 0//1*one(x)
B₇′′ = x ->   1//1 ≤ x <   2//1 ?       150//169*x -      150//169 :
              2//1 ≤ x ≤  18//5 ? -126375//43264*x + 145575//21632 : 0//1*one(x)
B₈′′ = x ->   2//1 ≤ x ≤  18//5 ? 375//256*x - 375//128 : 0//1*one(x)
# 3rd derivative
B₁′′′ = x ->  -5//1 ≤ x <  -7//2 ? -16//9*one(x) : 0//1*one(x)
B₂′′′ = x ->  -5//1 ≤ x <  -7//2 ? 1429//441*one(x) :
              -7//2 ≤ x < -11//5 ? -375//637*one(x) : 0//1*one(x)
B₃′′′ = x ->  -5//1 ≤ x <  -7//2 ?  -250//147*one(x) :
              -7//2 ≤ x < -11//5 ? 5930//5733*one(x) :
             -11//5 ≤ x <   1//1 ?     -5//72*one(x) : 0//1*one(x)
B₄′′′ = x ->  -5//1 ≤ x <  -7//2 ?       5//21*one(x) :
              -7//2 ≤ x < -11//5 ? -5695//9009*one(x) :
             -11//5 ≤ x <   1//1 ?  1255//5544*one(x) :
               1//1 ≤ x <   2//1 ?     -20//77*one(x) : 0//1*one(x)
B₅′′′ = x ->  -7//2 ≤ x < -11//5 ?       80//429*one(x) :
             -11//5 ≤ x <   1//1 ? -12535//53592*one(x) :
               1//1 ≤ x <   2//1 ?  26240//29029*one(x) :
               2//1 ≤ x ≤  18//5 ?    -375//1508*one(x) : 0//1*one(x)
B₆′′′ = x -> -11//5 ≤ x <   1//1 ?      125//1624*one(x) :
               1//1 ≤ x <   2//1 ?  -52550//34307*one(x) :
               2//1 ≤ x ≤  18//5 ? 267375//156832*one(x) : 0//1*one(x)
B₇′′′ = x ->   1//1 ≤ x <   2//1 ?       150//169*one(x) :
               2//1 ≤ x ≤  18//5 ? -126375//43264*one(x) : 0//1*one(x)
B₈′′′ = x ->   2//1 ≤ x ≤  18//5 ? 375//256*one(x) : 0//1*one(x)

b6_exact = [B₁ B₁′ B₁′′ B₁′′′; B₂ B₂′ B₂′′ B₂′′′; B₃ B₃′ B₃′′ B₃′′′; B₄ B₄′ B₄′′ B₄′′′;
            B₅ B₅′ B₅′′ B₅′′′; B₆ B₆′ B₆′′ B₆′′′; B₇ B₇′ B₇′′ B₇′′′; B₈ B₈′ B₈′′ B₈′′′]

b7 = BSplineBasis(3, Int8[-6,-4,-2,0,0,1,2])

B₁ = x -> -6 ≤ x < -4 ? 1//4*x^2 + 2//1*x + 4//1 : 0//1*one(x)
B₂ = x -> -6 ≤ x < -4 ? -3//8*x^2 - 7//2*x - 15//2 :
          -4 ≤ x < -2 ?  1//8*x^2 + 1//2*x +  1//2 : 0//1*one(x)
B₃ = x -> -6 ≤ x < -4 ?  1//8*x^2 + 3//2*x + 9//2 :
          -4 ≤ x < -2 ? -1//4*x^2 - 3//2*x - 3//2 :
          -2 ≤ x <  0 ?  1//8*x^2                 : 0//1*one(x)
B₄ = x -> -4 ≤ x < -2 ?  1//8*x^2 + 1//1*x + 2//1 :
          -2 ≤ x <  0 ? -3//8*x^2 - 1//1*x        : 0//1*one(x)
B₅ = x -> -2 ≤ x <  0 ? 1//4*x^2 + 1//1*x + 1//1 :
           0 ≤ x <  1 ? 1//1*x^2 - 2//1*x + 1//1 : 0//1*one(x)
B₆ = x ->  0 ≤ x <  1 ? -3//2*x^2 + 2//1*x        :
           1 ≤ x ≤  2 ?  1//2*x^2 - 2//1*x + 2//1 : 0//1*one(x)
B₇ = x ->  0 ≤ x <  1 ?  1//2*x^2                 :
           1 ≤ x ≤  2 ? -3//2*x^2 + 4//1*x - 2//1 : 0//1*one(x)
B₈ = x ->  1 ≤ x ≤  2 ? 1//1*x^2 - 2//1*x + 1//1 : 0//1*one(x)
# 1st derivatives
B₁′ = x -> -6 ≤ x < -4 ? 1//2*x + 2//1 : 0//1*one(x)
B₂′ = x -> -6 ≤ x < -4 ? -3//4*x - 7//2 :
           -4 ≤ x < -2 ?  1//4*x + 1//2 : 0//1*one(x)
B₃′ = x -> -6 ≤ x < -4 ?  1//4*x + 3//2 :
           -4 ≤ x < -2 ? -1//2*x - 3//2 :
           -2 ≤ x <  0 ?  1//4*x        : 0//1*one(x)
B₄′ = x -> -4 ≤ x < -2 ?  1//4*x + 1//1 :
           -2 ≤ x <  0 ? -3//4*x - 1//1 : 0//1*one(x)
B₅′ = x -> -2 ≤ x <  0 ? 1//2*x + 1//1 :
            0 ≤ x <  1 ? 2//1*x - 2//1 : 0//1*one(x)
B₆′ = x ->  0 ≤ x <  1 ? -3//1*x + 2//1 :
            1 ≤ x ≤  2 ?  1//1*x - 2//1 : 0//1*one(x)
B₇′ = x ->  0 ≤ x <  1 ?  1//1*x        :
            1 ≤ x ≤  2 ? -3//1*x + 4//1 : 0//1*one(x)
B₈′ = x ->  1 ≤ x ≤  2 ? 2//1*x - 2//1 : 0//1*one(x)
# 2nd derivatives
B₁′′ = x -> -6 ≤ x < -4 ? 1//2*one(x) : 0//1*one(x)
B₂′′ = x -> -6 ≤ x < -4 ? -3//4*one(x) :
            -4 ≤ x < -2 ?  1//4*one(x) : 0//1*one(x)
B₃′′ = x -> -6 ≤ x < -4 ?  1//4*one(x) :
            -4 ≤ x < -2 ? -1//2*one(x) :
            -2 ≤ x <  0 ?  1//4*one(x) : 0//1*one(x)
B₄′′ = x -> -4 ≤ x < -2 ?  1//4*one(x) :
            -2 ≤ x <  0 ? -3//4*one(x) : 0//1*one(x)
B₅′′ = x -> -2 ≤ x <  0 ? 1//2*one(x) :
             0 ≤ x <  1 ? 2//1*one(x) : 0//1*one(x)
B₆′′ = x ->  0 ≤ x <  1 ? -3//1*one(x) :
             1 ≤ x ≤  2 ?  1//1*one(x) : 0//1*one(x)
B₇′′ = x ->  0 ≤ x <  1 ?  1//1*one(x) :
             1 ≤ x ≤  2 ? -3//1*one(x) : 0//1*one(x)
B₈′′ = x ->  1 ≤ x ≤  2 ? 2//1*one(x) : 0//1*one(x)

b7_exact = [B₁ B₁′ B₁′′; B₂ B₂′ B₂′′; B₃ B₃′ B₃′′; B₄ B₄′ B₄′′; B₅ B₅′ B₅′′; B₆ B₆′ B₆′′; B₇ B₇′ B₇′′; B₈ B₈′ B₈′′]

# Compare arrays element-wise, and use a non-zero atol
≈ₑₗ(x::AbstractArray, y::AbstractArray) = all(x .≈ₑₗ y)
≈ₑₗ(x::Number, y::Number) = isapprox(x, y; atol=1e-15, rtol = Base.rtoldefault(x,y,0))
